fix pxe server leaving background procs
[automated-distro-installer] / fai-revm
index 97bb1a8abd16e363425e773a07ba75771466f5d3..6271a36bfa4980f3be53fa0ca4dd1efe977d4141 100755 (executable)
--- a/fai-revm
+++ b/fai-revm
-#!/bin/bash -lx
+#!/bin/bash -l
+# Copyright (C) 2016 Ian Kelling
+
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+set -x
+
+# Note, sometimes shutting down the existing demohost vm
+# fails. Just run again if that happens.
 
 # Deploy fai configuration to faiserver,
 # then start a virtual machine to test the config.
 
+cleanup() { :; }
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+trap 'cleanup; echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
+script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
+
+e() { echo "$*"; "$@"; }
+
+# I had this set false as default before, can't remember why. oh well.
+redeploy=true
+if [[ $1 == -r ]]; then
+    redeploy=false
+fi
+
+disk_count=2
+
+
+if [[ $script_dir == /a/bin/* ]]; then
+    # Copy our script elsewhere so we can develop it
+    # and save it at the same time it's running
+    rm -rf /tmp/faifreeze
+    mkdir -p /a/tmp
+    cp -ar /a/bin/fai /tmp/faifreeze
+    exec /tmp/faifreeze/${BASH_SOURCE##*/} "$@"
+fi
+
+cd $script_dir
+
+is_arch_revm() {
+    [[ ${0##*/} == arch-revm ]]
+}
 
 new_disk=false
 [[ ! $1 ]] || new_disk=true
 
-cd "${BASH_SOURCE%/*}"
-
-[[ $0 == *arch-revm ]] || ./fai-redep
+cleanup() { ./pxe-server :; }
+if is_arch_revm; then
+    ./pxe-server arch
+    sleep 2
+    # via osinfo-query os. guessing arch is closest to latest fedora.
+    variant=fedora22
+else
+    ./pxe-server fai
+    sleep 2
+    if $redeploy; then
+        ./fai-redep
+    fi
+    variant=debian8
+fi
 
 name=demohost
 
-s virshrm $name ||:
+s virshrm $name ||:
 
-for f in /var/lib/libvirt/images/${name}{,b}; do
+
+disk_arg=()
+for ((i=1; i <= disk_count; i++)); do
+    f=/var/lib/libvirt/images/${name}$i
+    disk_arg+=("--disk path=$f")
     if $new_disk || [[ ! -e $f ]]; then
-        s qemu-img create -o preallocation=metadata -f qcow2 $f 30G
+        s rm -f $f
+        e s qemu-img create -o preallocation=metadata -f qcow2 $f 20G
     fi
 done
 
-disk_arg=("--disk path=/var/lib/libvirt/images/$name"{,b})
-s virt-install --os-variant debian8 --cpu host -n $name --pxe -r 2048 --vcpus 1 \
-  ${disk_arg[*]} -w bridge=br0,mac=52:54:00:9c:ef:ad &
+if [[ $SSH_CLIENT ]]; then
+    console_arg=--noautoconsole
+fi
+
+# --cpu host: this causes mkfs.btrfs to fail with a stack trace which began
+# something like:
+# init_module+0x108/0x1000 [raid6_pq]
+#
+# uniq is to stop gtk-warning spam
+e s virt-install --os-variant $variant  -n $name --pxe -r 2048 --vcpus 1 \
+  ${disk_arg[*]} -w bridge=br0,mac=52:54:00:9c:ef:ad \
+  --graphics spice,listen=0.0.0.0 $console_arg |& grep -v '^ *$' | uniq &
+
+if [[ $SSH_CLIENT ]]; then
+    fg
+fi
 
-if [[ $0 == *arch-revm ]]; then
-    sleep 80
+sleep 30
+while ! timeout -s 9 10 ssh root@$name /bin/true; do sleep 5; done
+cleanup() { :; }
+pxe-server :
+if is_arch_revm; then
     ./arch-init-remote $name
 fi